<ng-template #elementBlockTemplate1>
        <div class="block-ui-template">
            <div class="sk-double-bounce sk-primary">
                <div class="sk-child sk-double-bounce1"></div>
                <div class="sk-child sk-double-bounce2"></div>
            </div>
            <p class="text-center text-white"> {{loadingText}} </p>
        </div>
    </ng-template>

    <!-- placement="bottom" [ngbPopover]="tooltip()" triggers="mouseenter:mouseleave" popoverTitle="Filters Applied" -->

    <!-- commenting for 1.3 <button *ngIf="!detectmob()" class="d-block ui-w-30 rounded-circle mr-2 cursor custom-btn text-center white" style="height: 30px;border-width:0px;"
        (click)="openFilterWindow()">
    <i class="las la-plus fa-lg"></i>
    </button> -->
    <button class="btn icon-btn btn-default" *ngIf="!detectmob()" style="border:0px;margin-top:4px" (click)="openFilterWindow()">
        <i  class="fa fa-lg fa-filter"></i>
        <i  class="fa fa-plus" style="line-height: 1.1"></i>
    </button>



    <!-- Filter Model for Web -->
    <div id="filter-web" class="loader-wrapper " *blockUI="blockUIName;  template: elementBlockTemplate1">
        <div class="filter-container" *ngIf="showFilterWindow">
            <div class="filterontent">
                <div class="filter-main-header">
                    <div class="row-one">
                        <div class="main-head modal-header">
                            <div class="modal-title">Select Your Filter Type</div>
                            <div class="text-right close-btn">
                                <i class="ion ion-md-close" aria-hidden="true" (click)="cancelClick()"></i>
                            </div>
                        </div>
                    </div>
                    <!-- Filter Apply -->
                    <div *ngIf="viewFilterdata.length > 0 && !deviceService.isMobile()" class="px-3 py-2"
                        style="width:100%;">
                        <label class="form-label label-material">Selected Filters</label>

                        <span
                            class="ml-2  "
                            placement="top" ngbTooltip="Selected Filter that will be applied to the result">
                            <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                        </span>

                        <!-- NEW -->
                        <!-- <div> -->
                        <!-- <div class="ml-1 values-align" *ngFor="let option of viewFilterdata">
                                <div ngbDropdown [placement]="isRTL ? 'bottom-right' : 'bottom-left'" class="d-inline-flex">
                                    <button class="btn btn-primary btn-sm" ngbDropdownToggle>{{option.name}}</button>
                                    <div ngbDropdownMenu [class.dropdown-menu-right]="isRTL" *ngIf="option.datefield">
                                        <a class="dropdown-item" href="javascript:void(0)">{{dateFormat(option)}}</a>
                                    </div>
                                    <div ngbDropdownMenu [class.dropdown-menu-right]="isRTL" *ngIf="!option.datefield" style="max-height: 400px;overflow:auto;">
                                            <a class="dropdown-item" href="javascript:void(0)" *ngFor="let val of splitItems(option.value)">{{val}}</a>
                                        </div>
                                </div>
                            </div> -->
                        <div class="w-100">
                            <div *ngFor="let filteritems of filterOptions;let i=index" class="d-inline-flex">
                                <div ngbDropdown [placement]="isRTL ? 'bottom-right' : 'bottom-left'"
                                    class="d-inline-flex mr-1 mb-1 values-align"
                                    *ngIf="filteritems.dirtyFlag && (filteritems.selectedValues.length>0) && !filteritems.datefield">
                                    <button class="btn btn-primary btn-sm btn-round"
                                        [ngClass]="currentSelectedItem==i?onChangeOnFilterItems:''"
                                        ngbDropdownToggle>{{filteritems.object_display}}</button>
                                    <!-- <div ngbDropdownMenu [class.dropdown-menu-right]="isRTL" *ngIf="filteritems.datefield">
                                        <a class="dropdown-item disabled"
                                            href="javascript:void(0)">{{dateFormat({'value':filteritems.object_name})}}</a>
                                    </div> -->
                                    <div ngbDropdownMenu [class.dropdown-menu-right]="isRTL"
                                        style="max-height: 400px;overflow:auto;">
                                        <a class="dropdown-item disabled" href="javascript:void(0)"
                                            *ngFor="let val of filteritems.selectedValues">{{val}}</a>
                                    </div>
                                </div>
                            </div>
                        </div>


                        <!-- </div> -->
                        <!-- <div class="entity-scroll-view" [perfectScrollbar]>
                            <div class="ml-5 align-ment" *ngIf="viewFilterdata.length>0">
                                <span class="badge-default badge badge-secondary">
                                    Filters Applied:</span>
                            </div>
                            <div class="ml-1 values-align row form-group group-label"
                                *ngFor="let option of viewFilterdata">
                                <label class="label label-style">{{option.name}}</label>
                                <div class="input-btn-group date-input-material"
                                style="padding-left:0.875rem; text-overflow: ellipsis; white-space: nowrap; max-width: 100%; overflow: hidden;height: auto;font-size: 10px;line-height: 1.1;">
                                    {{dateFormat(option)}}
                                </div>
                            </div>
                        </div> -->
                        <!-- NEW -->
                    </div>
                    <!-- Filter Apply -->
                </div>

                <div class="app-filter-content">
                    <div class="row-two filter-header" *ngIf="!deviceService.isMobile()">
                        <div class="col-title px-3 py-2">
                            <label class="form-label label-material">Filter Options</label>
                            <span
                                class="ml-2  "
                                placement="top" ngbTooltip="Search filter options to select">
                                <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                            </span>
                            <div class="input-group">
                                <input class="form-control form-material" placeholder="Search for..." type="text"
                                    [(ngModel)]="searchText_filterObj" (keyup)="onSearchInput($event, 'filterObj')">
                                <span class="form-btn" *ngIf="searchText_filterObj != ''"
                                    (click)="clearSearchText('filterObj')"><i class="fa fa-times"
                                        aria-hidden="true"></i></span>
                            </div>
                        </div>

                        <div class="col-title px-3 py-2" style="border-left:1px solid #e7e7e7">
                            <label class="form-label label-material">Filter Values</label>
                            <span class="ml-2  "
                                placement="top" ngbTooltip="Search filter type to select values">
                                <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                            </span>
                            <div class="input-group">
                                <input class="form-control form-material" placeholder="Search for..." type="text"
                                    [(ngModel)]="searchText_filterVal" (keyup)="onSearchInput($event, 'filterVal')">
                                <span class="form-btn" *ngIf="searchText_filterVal != ''"
                                    (click)="clearSearchText('filterVal')"><i class="fa fa-times"
                                        aria-hidden="true"></i></span>
                            </div>

                            <div *ngIf="!isdateField" class="select_all float-right ml-2" style="padding-top: 7px;">
                                <label class="custom-control custom-checkbox m-0">
                                    <input type="checkbox" class="custom-control-input" name="Select/UnSelect All"
                                        [(ngModel)]="isSelectAll" [checked]="isSelectAll" (change)="selectAll()">
                                    <span class="custom-control-label checkbox-label">Select All</span>
                                </label>
                            </div>
                            <div class="float-right mt-2 mr-2 text-dark" style="padding-top: 4px;" placement="top"
                            ngbTooltip="Reset filter values"><i
                                    class="fas fa-sync-alt" (click)="resetClick()"></i></div>
                        </div>
                    </div>
                    <div class="row-three">
                        <div class="filter-list">
                            <ul class="list-group">
                                <li class="list-group-item" *ngFor="let option of filterOptions_copy; let i=index;"
                                    [ngClass]="{'active':selectedItem == option}" (click)="itemSelected(option,i)">
                                    <div class="filter-left-item">{{option.object_display}}</div>
                                    <span class="badge float-right">{{option.badge}}</span>
                                </li>
                            </ul>
                        </div>

                        <div class="filter-list filter-overflow-hidden" *ngIf="!selectedItem_copy.datefield"
                            appInfinitescroll (scrolled)="updateScrollPos($event)">
                            <ul class="list-group">
                                <li class="list-group-item" *ngFor="let value of selectedItem_copy.values"
                                    (click)="multiValueChanged(selectedItem_copy, value)">
                                    <span *ngIf="!selectedItem_copy.datefield && value">{{value.value}}</span>

                                    <span *ngIf="!selectedItem_copy.datefield" class="float-right icon-material">
                                        <i [ngClass]="{'fas fa-check':value.selected}" aria-hidden="true"></i>
                                    </span>
                                </li>
                                <li class="list-group-item"
                                    *ngIf="selectedItem_copy.values && !selectedItem_copy.values.length>0">
                                    No data to select
                                </li>
                                <li class="list-group-item" *ngIf="!selectedItem_copy.values">
                                    <span class="text-danger" *ngIf="!value">{{isFilterFetchFail}}</span>
                                </li>
                            </ul>
                        </div>
                        <!-- <div class="filter-list" *ngIf="selectedItem_copy.datefield">
                            <ul class="list-group">
                                <li class="list-group-item" *ngFor="let value of selectedItem_copy.values"
                                    (click)="multiValueChanged(selectedItem_copy, value)">
                                    <div class="input-group-sm" *ngIf="selectedItem_copy.datefield">

                                        <input class="form-control" type="date"
                                            [value]="selectedItem_copy.values[0].dateValue | date:'yyyy-MM-dd'"
                                            data-date-format="yyyy-MM-dd"
                                            (input)="selectedItem_copy.values[0].dateValue = dateValueChanged(selectedItem_copy,$event.target.value)" />

                                    </div>
                                </li>
                            </ul>
                        </div> -->
                    </div>
                </div>
                <div class="app-filter-btn modal-footer">
                    <button type="button" class="btn btn-default device-btn" (click)="cancelClick()">Cancel</button>
                    <!-- <button type="button" class="btn btn-default device-btn" (click)="resetAllClick()">Reset All</button> -->
                    <button type="button" class="btn btn-primary device-btn" (click)="applyClicked()">Apply</button>
                </div>
            </div>
        </div>
    </div>
    <!-- Filter Model for Web -->




    <!-- Filter Model for Mobile (Tab menu) -->